//
// IDomVisitor.cs
//
// Author:
//   Mike Krüger <mkrueger@novell.com>
//
// Copyright (C) 2008 Novell, Inc (http://www.novell.com)
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;

namespace MonoDevelop.Projects.Dom
{
	public interface IDomVisitable
	{
		object AcceptVisitor (IDomVisitor visitor, object data);
	}
	
	public interface IDomVisitor
	{
		object Visit (ICompilationUnit unit, object data);
		
		object Visit (IAttribute attribute, object data);
		
		object Visit (IType type, object data);
		
		object Visit (IField field, object data);
		object Visit (IMethod method, object data);
		object Visit (IProperty property, object data);
		object Visit (IEvent evt, object data);
		
		object Visit (IReturnType returnType, object data);
		object Visit (IParameter parameter, object data);
		object Visit (IUsing u, object data);
		object Visit (Namespace namesp, object data);
		
		object Visit (LocalVariable var, object data);
	}
}
